CREATE OR REPLACE TRIGGER TRG_USER_EVENT_ERC_EVENT_OUT
  AFTER
UPDATE
    OR
DELETE
    ON
    USER_EVENT_ERC
  FOR EACH ROW
DECLARE
  feedback_status NUMERIC(16);

counter NUMERIC(16);
BEGIN
    IF (updating
        AND (:new.status IS NULL
            OR (:new.status = :old.status)
                OR
     :new.event_out IS NULL)) THEN
    RETURN;
END IF;

IF (deleting
    AND (:old.status IS NULL
        OR :old.event_out IS NULL)) THEN
    RETURN;
END IF;

IF (updating) THEN
UPDATE
    event_out
SET
    erc_status = :new.status,
    trace = :new.trace
WHERE
    id = :new.event_out;

IF (:new.operation IN (1, 2, 6, 7, 8, 10, 11)) THEN
      IF (:new.status = 1) THEN
        feedback_status := 1;

elsif (:new.status >= 2) THEN
        feedback_status := 2;
ELSE
        feedback_status := -1;
END IF;

IF (feedback_status <> -1) THEN
        IF (:new.operation IN (1, 2)) THEN
SELECT
    count(1)
INTO
    counter
FROM
    feedback
WHERE
    lower(funct_application) = lower(:new.application)
    AND lower(APPLICATION) = lower(:new.target)
    AND lower(funct_type) = lower(:new.attr2)
    AND lower(funct) = lower(:new.attr1)
    AND lower(cod_operation) = lower(:new.cod_operation)
    AND operation = :new.operation
    AND user_erc = :new.user_erc;

elsif (:new.operation IN (6, 7, 8, 10)) THEN
SELECT
    count(1)
INTO
    counter
FROM
    feedback
WHERE
    lower(APPLICATION) = lower(:new.target)
    AND lower(cod_operation) = lower(:new.cod_operation)
    AND operation = :new.operation
    AND user_erc = :new.user_erc;

elsif (:new.operation = 11) THEN
SELECT
    count(1)
INTO
    counter
FROM
    feedback,
    pwdmanagement
WHERE
    lower(APPLICATION) = lower(:new.target)
    AND lower(cod_operation) = lower(:new.cod_operation)
    AND operation = :new.operation
    AND user_erc = :new.user_erc
    AND authorizations = pwdmanagement.id
    AND lower(pwdmanagement.code) = lower(:new.user_id);
END IF;

IF (counter = 1) THEN
          IF (:new.operation IN (1, 2)) THEN
UPDATE
    feedback
SET
    status = feedback_status
WHERE
    lower(funct_application) = lower(:new.application)
    AND lower(APPLICATION) = lower(:new.target)
    AND lower(funct_type) = lower(:new.attr2)
    AND lower(funct) = lower(:new.attr1)
    AND lower(cod_operation) = lower(:new.cod_operation)
    AND operation = :new.operation
    AND user_erc = :new.user_erc;

elsif (:new.operation IN (6, 7, 8, 10)) THEN
UPDATE
    feedback
SET
    status = feedback_status
WHERE
    lower(APPLICATION) = lower(:new.target)
    AND lower(cod_operation) = lower(:new.cod_operation)
    AND operation = :new.operation
    AND user_erc = :new.user_erc;

elsif (:new.operation = 11) THEN
UPDATE
    feedback
SET
    status = feedback_status
WHERE
    lower(APPLICATION) = lower(:new.target)
    AND lower(cod_operation) = lower(:new.cod_operation)
    AND operation = :new.operation
    AND user_erc = :new.user_erc
    AND authorizations IN
                   (
    SELECT
        pwdmanagement.id
    FROM
        pwdmanagement
    WHERE
        lower(code) = lower(:new.user_id));
END IF;
END IF;
END IF;
END IF;

elsif (deleting) THEN
UPDATE
    event_out
SET
    erc_status = :old.status,
    trace = :old.trace
WHERE
    id = :old.event_out;

IF (:old.operation IN (1, 2, 6, 7, 8, 9, 10, 11)) THEN
      IF (:old.status = 1) THEN
        feedback_status := 1;

elsif (:old.status >= 2) THEN
        feedback_status := 2;
ELSE
        feedback_status := -1;
END IF;

IF (feedback_status <> -1) THEN
        IF (:old.operation IN (1, 2)) THEN
SELECT
    count(1)
INTO
    counter
FROM
    feedback
WHERE
    lower(funct_application) = lower(:old.application)
    AND lower(APPLICATION) = lower(:old.target)
    AND lower(funct_type) = lower(:old.attr2)
    AND lower(funct) = lower(:old.attr1)
    AND lower(cod_operation) = lower(:old.cod_operation)
    AND operation = :old.operation
    AND user_erc = :old.user_erc;

elsif (:old.operation IN (6, 7, 8, 9, 10)) THEN
SELECT
    count(1)
INTO
    counter
FROM
    feedback
WHERE
    lower(APPLICATION) = lower(:old.target)
    AND lower(cod_operation) = lower(:old.cod_operation)
    AND operation = :old.operation
    AND user_erc = :old.user_erc;

elsif (:old.operation = 11) THEN
SELECT
    count(1)
INTO
    counter
FROM
    feedback,
    pwdmanagement
WHERE
    lower(APPLICATION) = lower(:old.target)
    AND lower(cod_operation) = lower(:old.cod_operation)
    AND operation = :old.operation
    AND user_erc = :old.user_erc
    AND authorizations = pwdmanagement.id
    AND lower(pwdmanagement.code) = lower(:old.user_id);
END IF;

IF (counter = 1) THEN
          IF (:old.operation IN (1, 2)) THEN
UPDATE
    feedback
SET
    status = feedback_status
WHERE
    lower(funct_application) = lower(:old.application)
    AND lower(APPLICATION) = lower(:old.target)
    AND lower(funct_type) = lower(:old.attr2)
    AND lower(funct) = lower(:old.attr1)
    AND lower(cod_operation) = lower(:old.cod_operation)
    AND operation = :old.operation
    AND user_erc = :old.user_erc;

elsif (:old.operation IN (6, 7, 8, 9, 10)) THEN
UPDATE
    feedback
SET
    status = feedback_status
WHERE
    lower(APPLICATION) = lower(:old.target)
    AND lower(cod_operation) = lower(:old.cod_operation)
    AND operation = :old.operation
    AND user_erc = :old.user_erc;

elsif (:old.operation = 11) THEN
UPDATE
    feedback
SET
    status = feedback_status
WHERE
    lower(APPLICATION) = lower(:old.target)
    AND lower(cod_operation) = lower(:old.cod_operation)
    AND operation = :old.operation
    AND user_erc = :old.user_erc
    AND authorizations IN
                   (
    SELECT
        pwdmanagement.id
    FROM
        pwdmanagement
    WHERE
        lower(code) = lower(:old.user_id));
END IF;
END IF;
END IF;
END IF;
END IF;
END TRG_USER_EVENT_ERC_EVENT_OUT;