CREATE OR REPLACE TRIGGER TRG_PWDMANAGEMENT_UPD_BEFORE
  BEFORE UPDATE ON PWDMANAGEMENT
  FOR EACH ROW
declare
  cur_pwdcfg sys_refcursor;
  feedB      boolean;
 
  v_target   varchar2(256);

  code_oper  varchar2(128);

  request_type	number(16);

  counter    number(16);

begin
	IF (:old.person IS NULL) THEN
		RETURN;
	END IF;
	if ( :old.CHANGELOG = :new.CHANGELOG ) then
		return;
	end if;
  select count(1) into counter from tmp_codoperation;
  if ( counter = 0 ) then
    RAISE_APPLICATION_ERROR ( -20200, 'NO OPERATION CODE FOUND IN TMP_CODOPERATION TABLE');
  elsif ( counter = 1 ) then
    select code into code_oper from tmp_codoperation;
  elsif  ( counter > 1 ) then
    RAISE_APPLICATION_ERROR ( -20201, 'TOO MANY OPERATION CODE FOUND IN TMP_CODOPERATION TABLE');
  end if;

feedB := false;

  if (code_oper is not null and INSTR(code_oper, 'ARM_', 1, 1) = 1) then
    SELECT REQ_TYPE INTO request_type FROM REQUEST  WHERE ID = REPLACE(code_oper, 'ARM_', '');
    -- checks only for account update requests
	if (request_type = 82) THEN 
		feedB := true;
	end if;
  end if;
  
	--manage the insert account for feedback 
    IF (feedB) THEN
      OPEN cur_pwdcfg FOR
        SELECT DISTINCT t.value
          FROM pwdcfg pwd, target t
         WHERE pwd.id = :new.pwdcfg
           AND pwd.id = t.pwdcfg
           AND pwd.sync = 2;
    
      LOOP
        FETCH cur_pwdcfg
          INTO v_target;
      
        EXIT WHEN cur_pwdcfg % NOTFOUND;
        -- checking whether target is available
        IF (v_target IS NOT NULL) THEN
          INSERT INTO feedback
            (id, authorizations, APPLICATION, cod_operation, operation)
          VALUES
            (feedback_seq.nextval, :new.id, v_target, code_oper, 10);
        END IF;
      END LOOP;
    
      CLOSE cur_pwdcfg;
    END IF;
    -- end manage the insert account for feedback
  
end TRG_PWDMANAGEMENT_UPD_BEFORE;
/